package com.jojubanking.boot.module.system.service.hospital;

import java.util.*;
import javax.validation.*;
import com.jojubanking.boot.module.system.controller.admin.hospital.vo.*;
import com.jojubanking.boot.module.system.dal.dataobject.hospital.HospitalDO;
import com.jojubanking.boot.framework.common.pojo.PageResult;

/**
 * 医院信息 Service 接口
 *
 * @author admin
 */
public interface HospitalService {

    /**
     * 创建医院信息
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Integer createHospital(@Valid HospitalCreateReqVO createReqVO);

    /**
     * 更新医院信息
     *
     * @param updateReqVO 更新信息
     */
    void updateHospital(@Valid HospitalUpdateReqVO updateReqVO);

    /**
     * 删除医院信息
     *
     * @param id 编号
     */
    void deleteHospital(Integer id);

    /**
     * 获得医院信息
     *
     * @param id 编号
     * @return 医院信息
     */
    HospitalDO getHospital(Integer id);

    /**
     * 获得医院信息列表
     *
     * @param ids 编号
     * @return 医院信息列表
     */
    List<HospitalDO> getHospitalList(Collection<Integer> ids);

    /**
     * 获得医院信息分页
     *
     * @param pageReqVO 分页查询
     * @return 医院信息分页
     */
    PageResult<HospitalDO> getHospitalPage(HospitalPageReqVO pageReqVO);

    /**
     * 获得医院信息列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 医院信息列表
     */
    List<HospitalDO> getHospitalList(HospitalExportReqVO exportReqVO);

}
